#include <mega8.h>
#include <delay.h>
#include <stdio.h>

#define INPUT_1 PINC.0
#define INPUT_2 PINC.2
#define INPUT_3 PINC.4

#define RELAY_1 PORTD.3
#define RELAY_2 PORTD.5
#define RELAY_3 PORTD.7

//usart start code
#ifndef RXB8
#define RXB8 1
#endif

#ifndef TXB8
#define TXB8 0
#endif

#ifndef UPE
#define UPE 2
#endif

#ifndef DOR
#define DOR 3
#endif

#ifndef FE
#define FE 4
#endif

#ifndef UDRE
#define UDRE 5
#endif

#ifndef RXC
#define RXC 7
#endif

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)




interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
#asm("cli")
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
             //this if is just an example you can set your IF's
              if( data=='1' ){   
              RELAY_1=1;
              }
               else{  
                RELAY_1=0;
               }      
               
              // send '2'  
                 if( data=='2' ){   
              RELAY_2=1;
              }
               else{  
                RELAY_2=0;
               } 
               // send '3'
                  if( data=='3' ){   
              RELAY_3=1;
              }
               else{  
                RELAY_3=0;
               } 
               
               }     
   
   #asm("sei")
}
//usart end code

void main(void){  
unsigned char to_send=0,temp=0; // Byte for send
//unsigned char i=0;  
DDRC=0X00;
DDRD=(1<<3)|(1<<5)|(1<<7); 
 
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x33;


#asm("sei")
  while(1){ 
  
    
  
           to_send=(INPUT_1<<0)|(INPUT_2<<1)|(INPUT_3<<2);       
           if( (to_send !=temp) & to_send !=0  ){         
            printf("%d",to_send);  
            temp=to_send;
           }  
          delay_ms(50);     
   }
}
